/*
Copyright 2010 Pierre SCHWARTZ

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
documentation files (the "Software"), to deal in the Software without restriction, including without 
limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following 
conditions: The above copyright notice and this permission notice shall be included in all copies or 
substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
*/

/*!
 * \file colormaker.h
 * \brief fichier de dfinition de la classe virtuelle de coloration d'image
 * \author Pierre Schwartz
 * \version 1.0
 */

#ifndef H__colormaker__
#define H__colormaker__

#include <QtGui/QColor>


/*! \class buddhabrot
* \brief Classe gnrique de coloration. Les colorations se basent sur les images gnres et un changement de 
coloration ne ncessite pas de recalcul complet des images.
*
*/
class colorMaker{
public:
	 /*!
     *  \brief Constructeur.
     *  \param nbColors : nombre de couleurs  considrer	 
     */
	colorMaker(int nbColors):nblevels(nbColors){}

	 /*!
     *  \brief Destructeur.
     */
	virtual ~colorMaker(){}

	 /*!
     *  \brief colorer un niveau de couleur.
     *
     *  \param level : valeur  colorer
	 *  \return valeur colore
     */
	virtual QColor get(int level) = 0;

	/*!
     *  \brief renvoit le nombre de couleurs gres
	 *  \return nombre de couleurs gres
     */
	int getNbLevels(){return nblevels;}
protected:
	int nblevels;
};

#endif
