/*
Copyright 2010 Pierre SCHWARTZ

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
documentation files (the "Software"), to deal in the Software without restriction, including without 
limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following 
conditions: The above copyright notice and this permission notice shall be included in all copies or 
substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
*/


/*!
 * \file commandlineargument.h
 * \brief fichier de dclaration de la classe CommandLineArguments, d'analyse de ligne de commande
 * \author Pierre Schwartz
 * \version 1.0
 */

#ifndef H_commandLineArguments__
#define H_commandLineArguments__

#include <QtCore>

/*! 
 * \class CommandLineArguments
 * \brief Cette classe permet d'analyse les arguments de la ligne de commande lors du rendu par webservice
 * \author Pierre Schwartz
 * \version 1.0
 */
class CommandLineArguments{
public :
	CommandLineArguments(int argc, char **argv);
	~CommandLineArguments();
	QString getFractale();
	QString getOutput();
	bool getAleatoire();
	QRectF getWindow();
	QSize getResolution();
	int getIterations();
	long getRandomCount();
	int getOffset();
	int getStep();
	bool isNetworkAgent();
private:
	QStringList data;
};

#endif
