/*
Copyright 2010 Pierre SCHWARTZ

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
documentation files (the "Software"), to deal in the Software without restriction, including without 
limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following 
conditions: The above copyright notice and this permission notice shall be included in all copies or 
substantial portions of the Software. THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF 
OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. 
*/

/*!
 * \file networkagent.h
 * \brief fichier de dfinition de la classe de calcul par webservice
 * \author Pierre Schwartz
 * \version 1.0
 */

#ifndef H__networkagent__
#define H__networkagent__

#include <QtCore>
#include "commandlinearguments.h"

/*! \class NetworkAgent
   * \brief Cette classe n'est instancie que via un webservice, elle calcule de manire non multithreade une partie d'une image
   */

class NetworkAgent{
public:
	NetworkAgent(QVector<QVector<long> >& result, QSize resolution, QRectF window, bool isRandom, QString fractaleName, int offset, int iterations, int nbRandom, QString output, int step);
	~NetworkAgent();

	static int process(CommandLineArguments&);
protected:
	QVector<QVector<long> >& result;
};

#endif

