#ifndef SEQUENCEACCUMULATOR_H
#define SEQUENCEACCUMULATOR_H

#include "accumulator.h"
#include <QVector>

/*!
 *	\class SequenceAccumulator
 *	Accumulateur sur la sequence
 *
 *	Cette classe offre un implementation d Accumulator
 *	Elle permet d accumuler une sequence de point
 *	@see Accumulator
 */
class SequenceAccumulator : public Accumulator
{
public:
	/// \sa Accumulator
	SequenceAccumulator(FractalInfo * info, QObject * parent = 0);
	///	\sa Accumulator::accumuler()
	virtual void accumuler(Complex &pInit, QVector<Complex> &seq);
};

#endif // SEQUENCEACCUMULATOR_H
