#ifndef NEWTON_H
#define NEWTON_H

#include "fractal.h"

/*!
 *	\class Newton
 *	Cette classe reprsente la fractale Newton
 *	@see Fractal
 */
class Newton : public Fractal
{
public:
	/// \sa Fractal
	Newton(int limit = 1000, QObject * parent = 0);
	/// \sa Fractal::genererSequence()
	virtual void genererSequence(const Complex &pInit, QVector<Complex> & sequence);

private:
	virtual Complex suivant(const Complex & Zn);
	virtual bool fin(const Complex & Zn);
};

#endif // NEWTON_H
